Subject: Re: [mif] I-D Action:draft-ietf-mif-current-practices-00.txt

From: "wudiyetc" <[email-masked]>
Date: Fri, 11 Dec 2009 16:27:14 +0800

Hello Alex:
       I think mif hope to talk about the host attched to multiple networks, so each interface of the host may be assigned different addresses, but "bonding" require every interfaces have the same address. So I personally think that  it is not suitable to contain it.

Regards
Wudi Ye

>MIFers,
>
>I have some comments on draft-ietf-mif-current-practices-00.
>
>First, I am happy it exists and seems very relevant to some needs.
>
>Section "3.2.2.  Linux and BSD-based Operating Systems" basically talks 
>DHCP and the problem of most implementations using a single default 
>route.  I agree with it.
>
>However, I would list more in this section.  When someone tries in 
>practice to use multiple interfaces on linux one gets quickly also to 
>the following tools:
>
>-bridging brconf
>-"bonding"
>-tc
>
>These have certain disadvantages, for example brconf only repeats 
>packets from one interface to another whereas what I want is to receive 
>packets from both interfaces to a 3rd interface.  "bonding" does that a 
>little bit, but only works on Ethernet, it doesn't work with a ppp0 
>interface, for example.  About tc I am not yet sure.
>
>There may be other tools I am not aware of and I would like to learn 
>about for using multiple interfaces simultaneously.
>
>Alex
>
>[email-masked] a ?crit :
>> A New Internet-Draft is available from the on-line Internet-Drafts directories.
>> This draft is a work item of the Multiple Interfaces Working Group of the IETF.
>> 
>> 
>> 	Title           : Current Practices for Multiple Interface Hosts
>> 	Author(s)       : M. Wasserman
>> 	Filename        : draft-ietf-mif-current-practices-00.txt
>> 	Pages           : 16
>> 	Date            : 2009-10-19
>> 
>>An increasing number of hosts are operating in multiple-interface
>> environments, where different network interfaces are providing
>> unequal levels of service or connectivity.  This document summarizes
>> current practices in this area, and describes in detail how some
>> common operating systems cope with these challenges.
>> 
>> A URL for this Internet-Draft is:
>> http://www.ietf.org/internet-drafts/draft-ietf-mif-current-practices-00.txt
>> 
>> Internet-Drafts are also available by anonymous FTP at:
>> ftp://ftp.ietf.org/internet-drafts/
>> 
>> Below is the data which will enable a MIME compliant mail reader
>> implementation to automatically retrieve the ASCII version of the
>> Internet-Draft.
>> 
>> 
>> ------------------------------------------------------------------------
>> 
>> _______________________________________________
>> I-D-Announce mailing list
>> [email-masked]
>> https://www.ietf.org/mailman/listinfo/i-d-announce
>> Internet-Draft directories: http://www.ietf.org/shadow.html
>> or ftp://ftp.ietf.org/ietf/1shadow-sites.txt

---

From: Alexandru Petrescu <[email-masked]>
Date: Fri, 11 Dec 2009 11:30:17 +0100

wudiyetc a écrit :
> Hello Alex:
>        I think mif hope to talk about the host attched to multiple 
> networks, so each interface of the host may be assigned different 
> addresses, but "bonding" require every interfaces have the same address. 
> So I personally think that  it is not suitable to contain it.

Hm, that's right, I think "bonding" will put the same address on two or 
more interfaces of same host.  I wouldn't discard its relevance for 
section 3.2.2, though.

I mean, I do not think DHCP is the only relevant tool for section 3.2.2.

Do you think DHCP is the only tool one has to consider when looking at 
several interfaces?  What are the other existing linux software one uses 
directly when trying to use multiple interfaces?  ebtables?  iptables? 
What software do _you_ use for this goal?

Another example, if the type of the multiple interfaces is wifi then 
hostap and iwconfig must be considered as well.  Multiple ESSID vs 
multiple VLANs on same ESSID is something which guide the way subnets 
and addresses are allocated.

Just some thoughts, thanks,

Alex

---

From: "Wudi Ye" <[email-masked]>
Date: Mon, 14 Dec 2009 19:59:33 +0800

I forgot to Cc the mail to the maillist before.

Hello, Alex:

     please see inline.

regards.
Wudi Ye.

>more interfaces of same host.  

I think so.

>I wouldn't discard its relevance for 
>section 3.2.2, though.

"Bonding"  can't be used in the scene that the host attaches multiple provision domain which is discribed in the MIF charter.
So I think not necessary to add it in the section3.2.2.

>What software do _you_ use for this goal?

I agree with you, and I think DHCP is a method to transfer 
route selection policy/address selection policy ,
iptables or other tools can be used for configure the host base 
the policy which is received through DHCP or other tool. 
We should list more tools in section3.2.2 , but not  beyond is as wrong as falling .

>and addresses are allocated.

I have no idea.

---

From: "wudiyetc" <[email-masked]>
Date: Mon, 14 Dec 2009 20:02:18 +0800

Forwarding Alex's mail to the list.

Regards,
Wudi Ye

Wudi Ye a écrit :
> "Bonding"  can't be used in the scene that the host attaches multiple 
> provision domain which is discribed in the MIF charter.
Ok...
> not  beyond is as wrong as falling .
Ok.
>  >and addresses are allocated.
Ok, hostap and iwconfig with multiple interfaces would also fall within 
the scope of same administrative domain, so probably irrelevant to mif.
Still, I am wondering which other software tool (other than dhcp tools) 
would one start with, when trying to deal with multiple interfaces.
Alex

---

From: "wudiyetc" <[email-masked]>
Date: Mon, 14 Dec 2009 20:43:34 +0800

Hello ,Alex:

       Advanced Socket API also can be use for multiple interface. 
And if DHCP Server isn't deployed in the subnet, the NDP may be used.
Is this wrong?

Wudi Ye

---

From: Alexandru Petrescu <[email-masked]>
Date: Mon, 14 Dec 2009 23:06:49 +0100

wudiyetc a écrit :
> 
> Hello ,Alex:
> 
> Advanced Socket API also can be use for multiple interface. And if
> DHCP Server isn't deployed in the subnet, the NDP may be used. Is
> this wrong?

WEll I guess yes, Neighbor Discovery and stateless address
auto-configuration may be used sometimes instead of DHCPv6.  That will
however configure a single default route on the end host (precisely as
DHCPv6 does) and, moreover, the end host typically uses a single entry
in the list of entries default route in the routing table.  (i.e. even
if there are multiple entries of default routes in the routing table
only the first is typically used).

I am trying to find out what are the existing software tools for
configuring the simultaneous use of several outgoing interfaces.

Alex

> 
> Wudi Ye
> 
> 
> 
>> Wudi Ye a écrit :
>>> Hello, Alex:
>>> 
>>> please see inline.
>>> 
>>> regards. Wudi Ye.
>>> 
>>> 
>>>> wudiyetc a écrit :
>>>>> Hello Alex: I think mif hope to talk about the host attched
>>>>> to multiple networks, so each interface of the host may be
>>>>> assigned different addresses, but "bonding" require every
>>>>> interfaces have the same address. So I personally think that
>>>>> it is not suitable to contain it.
>>>> Hm, that's right, I think "bonding" will put the same address
>>>> on two or more interfaces of same host.
>>> 
>>> I think so.
>>> 
>>>> I wouldn't discard its relevance for section 3.2.2, though.
>>> 
>>> "Bonding"  can't be used in the scene that the host attaches
>>> multiple provision domain which is discribed in the MIF charter. 
>>>> I mean, I do not think DHCP is the only relevant tool for
>>>> section 3.2.2. Do you think DHCP is the only tool one has to
>>>> consider when looking at several interfaces?  What are the
>>>> other existing linux software one uses directly when trying to
>>>> use multiple interfaces?  ebtables?  iptables? What software do
>>>> _you_ use for this goal?
>>> 
>>> I agree with you, and I think DHCP is a method to transfer route
>>> selection policy/address selection policy , iptables or other
>>> tools can be used for configure the host base the policy which is
>>> received through DHCP or other tool. We should list more tools in
>>> section3.2.2 , but not  beyond is as wrong as falling .
>> Ok.
>>>> Another example, if the type of the multiple interfaces is wifi
>>>> then hostap and iwconfig must be considered as well.  Multiple
>>>> ESSID vs multiple VLANs on same ESSID is something which guide
>>>> the way subnets and addresses are allocated.
>>> 
>>> I have no idea.
>> Ok, hostap and iwconfig with multiple interfaces would also fall
>> within the scope of same administrative domain, so probably
>> irrelevant to mif. Still, I am wondering which other software tool
>> (other than dhcp tools) would one start with, when trying to deal
>> with multiple interfaces. Alex
>>> 
>>>> Just some thoughts, thanks, Alex
>>>>> 
>>>>> Regards Wudi Ye
>>>>> 
>>>>> 
>>>>>> MIFers,
>>>>>> 
>>>>>> I have some comments on
>>>>>> Section "3.2.2.  Linux and BSD-based Operating Systems"
>>>>>> basically talks DHCP and the problem of most
>>>>>> implementations using a single default route.  I agree with
>>>>>> it.
>>>>>> 
>>>>>> However, I would list more in this section.  When someone
>>>>>> tries in practice to use multiple interfaces on linux one
>>>>>> gets quickly also to the following tools:
>>>>>> 
>>>>>> -bridging brconf -"bonding" -tc
>>>>>> 
>>>>>> These have certain disadvantages, for example brconf only
>>>>>> repeats packets from one interface to another whereas what
>>>>>> I want is to receive packets from both interfaces to a 3rd
>>>>>> interface.  "bonding" does that a little bit, but only
>>>>>> works on Ethernet, it doesn't work with a ppp0 interface,
>>>>>> for example.  About tc I am not yet sure.
>>>>>> 
>>>>>> There may be other tools I am not aware of and I would like
>>>>>> to learn about for using multiple interfaces
>>>>>> simultaneously.
>>>>>> 
>>>>>> Alex
>>>>>> 
>>>>>>> A New Internet-Draft is available from the on-line
>>>>>>> Internet-Drafts
>>>> directories.
>>>>>>> This draft is a work item of the Multiple Interfaces
>>>>>>> Working Group
>>>> of the IETF.
>>>>>>> 
>>>>>>> 
>>>>>>> Title           : Current Practices for Multiple
>>>>>>> Interface Hosts Author(s)       : M. Wasserman Filename
>>>>>>> : draft-ietf-mif-current-practices-00.txt Pages
>>>>>>> : 16 Date            : 2009-10-19
>>>>>>> 
>>>>>>> An increasing number of hosts are operating in
>>>>>>> multiple-interface environments, where different network
>>>>>>> interfaces are providing unequal levels of service or
>>>>>>> connectivity.  This document summarizes current practices
>>>>>>> in this area, and describes in detail how some common
>>>>>>> operating systems cope with these challenges.
>>>>>>> 
>>>>>>> Below is the data which will enable a MIME compliant mail
>>>>>>> reader implementation to automatically retrieve the ASCII
>>>>>>> version of the Internet-Draft.
>>>

---

From: "Laganier, Julien" <[email-masked]>
Date: Mon, 14 Dec 2009 14:20:36 -0800

Alex, 

RFC 4191 describes support for "Default Router Preferences and More-Specific Routes" for Neighbor Discovery. 

--julien

> -----Original Message-----
> From: [email-masked] [mailto:[email-masked]] On Behalf Of
> Alexandru Petrescu
> Sent: Monday, December 14, 2009 2:07 PM
> To: wudiyetc
> Cc: mif
> Subject: Re: [mif] I-D Action:draft-ietf-mif-current-practices-00.txt
> 
> wudiyetc a écrit :
> >
> > Hello ,Alex:
> >
> mif mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mif

---

From: Zhen Cao <[email-masked]>
Date: Tue, 15 Dec 2009 16:39:57 +0800

> configuring the simultaneous use of several outgoing interfaces.
Hi, Alex,

I came across a note on this issue. http://www.ssi.bg/~ja/nano.txt. I
went through it but have not tried it. Still if you can configure your
gateway to add some source routing policy, simultaneous use of
outgoing interfaces is not a big issue.

Thanks,
Zhen

---

From: Zhen Cao <[email-masked]>
Date: Tue, 15 Dec 2009 16:42:40 +0800

> And if DHCP Server isn't deployed in the subnet, the NDP may be used.
Hi Wudi,

I agree, Advanced Socket API is definitely one way to support multiple
interface. We have posted one draft on this and will update it to
encapsulate more issues on this.

Thanks,
Zhen

---

From: Marc Blanchet <[email-masked]>
Date: Tue, 15 Dec 2009 07:32:30 -0500

the problem statement draft discusses about the Advanced Socket API.

Marc.

---

From: "wudiyetc" <[email-masked]>
Date: Tue, 15 Dec 2009 21:03:56 +0800

Hello Zhen ,
 
       I agree with you to extend the existing APIs, It can support MIF better.
But maybe you have  misunderstood my words.I mean existing Advanced Socket APIs 
can be used for multiple interface. e.g: the socket option SO_BINDTODEVICE can be 
used to specify the outgoing interface, and bind() can be used to bind a specified address 
to a socket.
 
Regards
Wudi Ye

---

From: Zhen Cao <[email-masked]>
Date: Tue, 15 Dec 2009 23:23:13 +0800

> used to specify the outgoing interface, and bind() can be used to bind a

But applications usually do not use this API. It is easier to select
the interface at the stack layer
And source address selection is part of the problem for MIF, policy
and configuration issues may need other APIs.

---

From: Zhen Cao <[email-masked]>
Date: Tue, 15 Dec 2009 23:37:17 +0800

Thanks. Yes, the problem statement draft currently discusses about the
socket API, in section 3.6 and 5(9), for address selection. And I
noticed that you opened a ticket for this issue. Are you going to
incorporate other text for this?  For example, RFC5014 only defines an
option to influence source address selection for IPv6. Do we need one
for IPv4?

Thanks,
Zhen
On Tue, Dec 15, 2009 at 8:32 PM, Marc Blanchet

---

From: "wudiyetc" <[email-masked]>
Date: Wed, 16 Dec 2009 10:44:03 +0800

Hi Marc,
Yes. As a existing relevant working, Advanced socket API should be listed in 
the draft-ietf-mif-current-practices-00.txt.

Thanks,
Wudi

---

From: "wudiyetc" <[email-masked]>
Date: Wed, 16 Dec 2009 10:49:55 +0800

>and configuration issues may need other APIs.

Yes.

Thanks,
Wudi

---

From: Alexandru Petrescu <[email-masked]>
Date: Wed, 16 Dec 2009 20:39:03 +0100

Zhen Cao a écrit :
>>> Advanced Socket API also can be use for multiple interface. And
>>> if DHCP Server isn't deployed in the subnet, the NDP may be used.
>>> Is this wrong?
>> auto-configuration may be used sometimes instead of DHCPv6.  That
>> will however configure a single default route on the end host
>> (precisely as DHCPv6 does) and, moreover, the end host typically
>> uses a single entry in the list of entries default route in the
>> routing table.  (i.e. even if there are multiple entries of default
>> routes in the routing table only the first is typically used).
>> 
>  went through it but have not tried it. Still if you can configure
> your gateway to add some source routing policy, simultaneous use of 

Does that documentation tell how to use several interfaces
simultaneously?  I don't think it does.

My problem is a router like this:

           |         |
           |egress1  |egress2
          -------------
         |  Router     |
          -------------
                 |ingress
                 |

I want the Router to use both egress1 and egress2 at the same time,
simultaneously.  I would like to be able to say that 50% of outgoing
traffic goes to egress1 and the other 50% goes to egress2.  This is not
a distinction per-application, or per-port number, or per-IP address.
But a distinction in time: the traffic sent by Router to the outside (on
the egress interfaces) should be split every 1s in a 50-50 manner.
Then I would like it to be parametrable, i.e. the 1s and the 50-50 to be
changeable.

I am listing the potential tools for achieving this, and the nano.txt
document is part of it, I have to read.

But right now I am vacationing :-)

Thanks,

Alex

> Thanks, Zhen